<?php
class User {
  private static $noExport = array();
  private $user_id;
  private $name;
  private $passwd;
  private $domains;
  
  public function __construct() {
    $user_id="";
    $name="";
    $passwd="";
    $domains=array();
  }
  
  public function __get($name) {
    if (array_key_exists($name, get_class_vars(get_class())) && !in_array($name, self::$noExport))
      return $this->$name;

    return null;
  }
  
  public function readData(DbConnection $DB, $conditions) {
    if(is_array($conditions)) {
      $whereConditions = array();
      foreach ($conditions as $key => $value)
        if(array_key_exists($key, get_class_vars(get_class())))
          $whereConditions[] = "$key=$value";
      $conditions =  implode(" AND ", $whereConditions);
    }
    $result = $DB->query("SELECT u.*, ".
                         "       group_concat(d.domain SEPARATOR ', ') domains ".
                         "FROM users u ".
                         "LEFT JOIN domains d ON (d.user_id=u.user_id) ".
                         "WHERE {$conditions};");
    
    if(!$DB->errno() && $DB->num_rows($result)==1) {
      $user = $DB->fetch_array($result);
      foreach ($user as $property => $value) {
        if(property_exists($this, $property)) {
          switch ($property) {
            case "domains":
              $this->$property = explode(", ", $value);
              break;
            default:
              $this->$property = $value;
              break;
          }
        }
      }
      
      return array(0, "");
    }
    else if ($DB->error())
      return array($DB->errno(), $DB->error());
    else if($DB->num_rows($result)>1)
      return array(1, "Username ambigous. Please contact the administrator.");
    else if($DB->num_rows($result)<1)
      return array(1, "Username does not exist.");
    else
      return array(1, "Unknown error.");
  }

  public function checkPW($passwd) {
    if(!$this->passwd) {
      if (!$passwd) 
        return true;
      else
        return false;
    }
    else {
      if (preg_match('~^\$([^$]+)\$(.{'.CWFTools::$SALT_LENGTH.'})~', $this->passwd, $match)) {
        $hashAlgorithm = $match[1];
        $salt = $match[2];
        $pwHash = CWFTools::getPasswordHash($passwd, $hashAlgorithm, $salt);
      }
      else {
        $pwHash = CWFTools::getPasswordHash($passwd, "md5", "");
        $pwHash = preg_replace('~^\$([^$]+)\$~', "", $pwHash);
      }
    }
    return ($pwHash == $this->passwd);
  }
}